'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _JSONArrow = require('./JSONArrow');

var _JSONArrow2 = _interopRequireDefault(_JSONArrow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ItemRange = function (_React$Component) {
  _inherits(ItemRange, _React$Component);

  function ItemRange(props) {
    _classCallCheck(this, ItemRange);

    var _this = _possibleConstructorReturn(this, (ItemRange.__proto__ || Object.getPrototypeOf(ItemRange)).call(this, props));

    _this.state = { expanded: false };

    _this.handleClick = _this.handleClick.bind(_this);
    return _this;
  }

  _createClass(ItemRange, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          styling = _props.styling,
          from = _props.from,
          to = _props.to,
          renderChildNodes = _props.renderChildNodes,
          nodeType = _props.nodeType;


      return this.state.expanded ? _react2.default.createElement(
        'div',
        styling('itemRange', this.state.expanded),
        renderChildNodes(this.props, from, to)
      ) : _react2.default.createElement(
        'div',
        _extends({}, styling('itemRange', this.state.expanded), {
          onClick: this.handleClick
        }),
        _react2.default.createElement(_JSONArrow2.default, {
          nodeType: nodeType,
          styling: styling,
          expanded: false,
          onClick: this.handleClick,
          arrowStyle: 'double'
        }),
        from + ' ... ' + to
      );
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      this.setState({ expanded: !this.state.expanded });
    }
  }]);

  return ItemRange;
}(_react2.default.Component);

ItemRange.propTypes = {
  styling: _propTypes2.default.func.isRequired,
  from: _propTypes2.default.number.isRequired,
  to: _propTypes2.default.number.isRequired,
  renderChildNodes: _propTypes2.default.func.isRequired,
  nodeType: _propTypes2.default.string.isRequired
};
exports.default = ItemRange;